/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20150930-64
 * Copyright (c) 2000 - 2015 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-0.aml, Tue Nov 24 08:29:52 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000003D4 (980)
 *     Revision         0x01
 *     Checksum         0xF6
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "SataAhci"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20130927 (538118439)
 */
DefinitionBlock ("SSDT-0.aml", "SSDT", 1, "HPQOEM", "SataAhci", 0x00001000)
{

    External (_SB_.PCI0.SATA, DeviceObj)
    External (DAMS, FieldUnitObj)
    External (DVS0, FieldUnitObj)
    External (DVS1, FieldUnitObj)
    External (DVS2, FieldUnitObj)
    External (DVS3, FieldUnitObj)
    External (GPIE, FieldUnitObj)
    External (GPIS, FieldUnitObj)
    External (ODDI, FieldUnitObj)
    External (ODDL, FieldUnitObj)
    External (ODDS, FieldUnitObj)
    External (ODPL, FieldUnitObj)

    Scope (\_SB.PCI0.SATA)
    {
        Device (PRT0)
        {
            Name (_ADR, 0xFFFF)  // _ADR: Address
            Name (FDEV, Zero)
            Name (FDRP, Zero)
            Method (_SDD, 1, Serialized)  // _SDD: Set Device Data
            {
                CreateByteField (Arg0, 0x9D, BFDS)
                ToInteger (BFDS, FDEV)
                CreateByteField (Arg0, 0x9A, BFRP)
                ToInteger (BFRP, FDRP)
            }

            Method (_GTF, 0, Serialized)  // _GTF: Get Task File
            {
                If (LAnd (LAnd (LEqual (DVS0, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Name (PIB1, Buffer (0x07)
                    {
                         0x10, 0x09, 0x00, 0x00, 0x00, 0xB0, 0xEF       
                    })
                    Return (PIB1)
                }

                Name (PIB2, Buffer (0x07)
                {
                     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00       
                })
                Return (PIB2)
            }
        }

        Device (PRT1)
        {
            Name (_ADR, 0x0001FFFF)  // _ADR: Address
            Name (FDEV, Zero)
            Name (FDRP, Zero)
            Method (_SDD, 1, Serialized)  // _SDD: Set Device Data
            {
                CreateByteField (Arg0, 0x9D, BFDS)
                ToInteger (BFDS, FDEV)
                CreateByteField (Arg0, 0x9A, BFRP)
                ToInteger (BFRP, FDRP)
            }

            Method (_GTF, 0, Serialized)  // _GTF: Get Task File
            {
                If (LAnd (LAnd (LEqual (DVS1, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Name (PIB1, Buffer (0x07)
                    {
                         0x10, 0x09, 0x00, 0x00, 0x00, 0xB0, 0xEF       
                    })
                    Return (PIB1)
                }

                Name (PIB2, Buffer (0x07)
                {
                     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00       
                })
                Return (PIB2)
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                If (LEqual (DAMS, 0x01))
                {
                    Return (HDSM (Arg0, Arg1, Arg2, Arg3))
                }
            }
        }

        Device (PRT2)
        {
            Name (_ADR, 0x0002FFFF)  // _ADR: Address
            Name (FDEV, Zero)
            Name (FDRP, Zero)
            Method (_SDD, 1, Serialized)  // _SDD: Set Device Data
            {
                CreateByteField (Arg0, 0x9D, BFDS)
                ToInteger (BFDS, FDEV)
                CreateByteField (Arg0, 0x9A, BFRP)
                ToInteger (BFRP, FDRP)
            }

            Method (_GTF, 0, Serialized)  // _GTF: Get Task File
            {
                If (LAnd (LAnd (LEqual (DVS2, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Name (PIB1, Buffer (0x07)
                    {
                         0x10, 0x09, 0x00, 0x00, 0x00, 0xB0, 0xEF       
                    })
                    Return (PIB1)
                }

                Name (PIB2, Buffer (0x07)
                {
                     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00       
                })
                Return (PIB2)
            }
        }

        Device (PRT3)
        {
            Name (_ADR, 0x0003FFFF)  // _ADR: Address
            Name (FDEV, Zero)
            Name (FDRP, Zero)
            Method (_SDD, 1, Serialized)  // _SDD: Set Device Data
            {
                CreateByteField (Arg0, 0x9D, BFDS)
                ToInteger (BFDS, FDEV)
                CreateByteField (Arg0, 0x9A, BFRP)
                ToInteger (BFRP, FDRP)
            }

            Method (_GTF, 0, Serialized)  // _GTF: Get Task File
            {
                If (LAnd (LAnd (LEqual (DVS3, 0x01), LEqual (And (FDEV, 0x01), 0x01)), LEqual (And (FDRP, 0x80), 0x80)))
                {
                    Name (PIB1, Buffer (0x07)
                    {
                         0x10, 0x09, 0x00, 0x00, 0x00, 0xB0, 0xEF       
                    })
                    Return (PIB1)
                }

                Name (PIB2, Buffer (0x07)
                {
                     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00       
                })
                Return (PIB2)
            }
        }

        Device (PRT5)
        {
            Name (_ADR, 0x0005FFFF)  // _ADR: Address
            Name (GTF5, Buffer (0x07)
            {
                 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00       
            })
            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                Store (Buffer (0x07)
                    {
                         0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00       
                    }, GTF5)
                Return (GTF5)
            }
        }
    }

    Method (HDSM, 4, Serialized)
    {
        If (LEqual (Arg0, ToUUID ("bdfaef30-aebb-11de-8a39-0800200c9a66")))
        {
            If (LEqual (ToInteger (Arg2), 0x00))
            {
                If (LEqual (ToInteger (Arg1), 0x01))
                {
                    Return (Buffer (0x01)
                    {
                         0x0F                                           
                    })
                }
                Else
                {
                    Return (Buffer (0x01)
                    {
                         0x00                                           
                    })
                }
            }
            Else
            {
                If (LEqual (ToInteger (Arg2), 0x01))
                {
                    Return (0x01)
                }
                Else
                {
                    If (LEqual (ToInteger (Arg2), 0x02))
                    {
                        Store (0x00, ODDS)
                        If (ODDL)
                        {
                            Store (0x01, ODDI)
                        }
                        Else
                        {
                            Store (0x00, ODDI)
                        }

                        Store (0x00, ODPL)
                        Sleep (0xC8)
                        Store (0x01, GPIS)
                        If (LNotEqual (GPIE, 0x01))
                        {
                            Store (0x01, GPIE)
                        }

                        Store (0x01, ODDS)
                        Return (0x01)
                    }
                    Else
                    {
                        If (LEqual (ToInteger (Arg2), 0x03))
                        {
                            Store (0x00, GPIE)
                            Store (0x01, GPIS)
                            Store (0x00, ODDS)
                            Store (0x01, ODPL)
                            Sleep (0x02BC)
                            Store (0x01, ODDS)
                            Return (0x01)
                        }
                        Else
                        {
                            Return (0x00)
                        }
                    }
                }
            }
        }
        Else
        {
            Return (0x00)
        }
    }
}

