/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20150930-64
 * Copyright (c) 2000 - 2015 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-2.aml, Tue Nov 24 08:29:52 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000041E (1054)
 *     Revision         0x01
 *     Checksum         0x42
 *     OEM ID           "Isct"
 *     OEM Table ID     "IsctAsl"
 *     OEM Revision     0x00003000 (12288)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20130927 (538118439)
 */
DefinitionBlock ("SSDT-2.aml", "SSDT", 1, "Isct", "IsctAsl", 0x00003000)
{

    External (_SB_.ODGW, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.GFX0.ASLC, FieldUnitObj)
    External (_SB_.PCI0.GFX0.ASLE, FieldUnitObj)
    External (_SB_.PCI0.GFX0.PARD, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.GFX0.STAT, FieldUnitObj)
    External (_SB_.PCI0.GFX0.TCHE, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.ECRG, IntObj)
    External (_SB_.PCI0.LPCB.EC0_.LIDS, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.SCCB, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.SCWD, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.SCWT, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.WLS3, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.WWS3, FieldUnitObj)

    Scope (\_SB)
    {
        Device (ISCT)
        {
            OperationRegion (SCTN, SystemMemory, 0x8BE3DD18, 0x0007)
            Field (SCTN, AnyAcc, Lock, Preserve)
            {
                WKRS,   8, 
                ASCT,   8, 
                AOS1,   8, 
                GNPT,   32
            }

            Name (_HID, "INT33A0")  // _HID: Hardware ID
            Name (_UID, 0x00)  // _UID: Unique ID
            Name (ANS1, 0x00)
            Name (AWS1, 0x00)
            Name (AOWD, 0x00)
            Method (GABS, 0, NotSerialized)
            {
                Return (ASCT)
            }

            Method (GAOS, 0, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    And (\_SB.PCI0.LPCB.EC0.SCCB, 0x03, Local0)
                }

                Return (Local0)
            }

            Method (SAOS, 1, NotSerialized)
            {
                \_SB.ODGW (Or (0x5400, Arg0))
                If (And (\_SB.PCI0.GFX0.TCHE, 0x0100))
                {
                    If (LAnd (LAnd (And (\_SB.PCI0.LPCB.EC0.SCCB, 0x01), And (WKRS, 0x40)), LNot (And (Arg0, 0x01))))
                    {
                        If (LNot (\_SB.PCI0.GFX0.PARD ()))
                        {
                            Store (And (\_SB.PCI0.GFX0.STAT, Not (0x03)), \_SB.PCI0.GFX0.STAT)
                            Store (Or (\_SB.PCI0.GFX0.ASLC, 0x0100), \_SB.PCI0.GFX0.ASLC)
                            Store (0x01, \_SB.PCI0.GFX0.ASLE)
                        }
                    }
                }

                If (LEqual (And (Arg0, 0x01), 0x01))
                {
                    Store (0x01, AOS1)
                }
                Else
                {
                    Store (0x00, AOS1)
                }

                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    Store (Arg0, \_SB.PCI0.LPCB.EC0.SCCB)
                }
            }

            Method (GANS, 0, NotSerialized)
            {
                Return (ANS1)
            }

            Method (SANS, 1, NotSerialized)
            {
                If (LEqual (And (Arg0, 0x01), 0x01))
                {
                    Store (0x01, ANS1)
                }
                Else
                {
                    Store (0x00, ANS1)
                }
            }

            Method (GWLS, 0, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC0.WLS3)
                {
                    Return (0x02)
                }
                Else
                {
                    Return (0x00)
                }
            }

            Method (SWLS, 1, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    If (LEqual (And (Arg0, 0x02), 0x02))
                    {
                        Store (0x01, \_SB.PCI0.LPCB.EC0.WLS3)
                    }
                    Else
                    {
                        Store (0x00, \_SB.PCI0.LPCB.EC0.WLS3)
                    }
                }
            }

            Method (GWWS, 0, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC0.WWS3)
                {
                    Return (0x02)
                }
                Else
                {
                    Return (0x00)
                }
            }

            Method (SWWS, 1, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    If (LEqual (And (Arg0, 0x02), 0x02))
                    {
                        Store (0x01, \_SB.PCI0.LPCB.EC0.WWS3)
                    }
                    Else
                    {
                        Store (0x00, \_SB.PCI0.LPCB.EC0.WWS3)
                    }
                }
            }

            Method (SASD, 1, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    Divide (Arg0, 0x1E, Local1, Local0)
                    Store (Local0, \_SB.PCI0.LPCB.EC0.SCWT)
                }
            }

            Method (GPWR, 0, NotSerialized)
            {
                Store (WKRS, Local0)
                Return (Local0)
            }

            Method (GPCS, 0, NotSerialized)
            {
                Store (0x01, Local0)
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    Store (\_SB.PCI0.LPCB.EC0.LIDS, Local0)
                }

                Return (Local0)
            }

            Method (GAWD, 0, NotSerialized)
            {
                Return (AOWD)
            }

            Method (SAWD, 1, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    Store (Arg0, \_SB.PCI0.LPCB.EC0.SCWD)
                }

                Store (Arg0, AOWD)
            }
        }
    }
}

